//@ sourceURL=user_manage.js
$(function () {
    $("input").each(function (){
        this.onkeydown = function (e) { // 监听键盘事件
            let theEvent = window.event || e;
            let code = theEvent.keyCode || theEvent.which;
            if (code == 13) {//回车事件
                $("#btn_search").click(); //触发搜索按钮点击事件
            }
        }
    });
    //新增按钮点击事件
    $("#btn_add").click(function (t) {
        $("#editModal").modal();
        $("#classTitle").text("新增");
        clearInput();
    });
    //角色保存按钮点击事件
    $("#btn_save").click(function (t) {
        var validatorResult = validator.checkAll($("#editGroupForm"));
        if (validatorResult) {
            saveGroupName();
        }
    });
    //初始化表格数据
    getAllGroupName();
    getAllDept();
});


//初始化部门下拉
function getAllDept() {
    $.ajax({
        type: "POST",
        url: '/thmz/allUnitCode',
        contentType: "application/json;charset=UTF-8",
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view';
                return;
            }
            if (res.code == 0) {
                //初始化部门下拉
                var arr = res.data;
                if (arr != null && arr.length > 0) {
                    var html = "";
                    for (var i = 0; i < arr.length; i++) {
                        html += "<option value='" + arr[i].code + "'>" + arr[i].name + "</option>";
                    }
                    $('#deptCode').html(html);
                    $('#deptCode').selectpicker('refresh');
                } else {
                    errorMesage(res);
                }
            }
        }
    });
}


/**
 * 保存药房数据
 */
function saveGroupName() {
    var data = JSON.stringify({
        groupNo: $("#groupNo").val(),
        deptCode: $("#deptCode").val(),
        groupName: $("#groupName").val(),
        mzFlag: $("#mzFlag").val(),
        yfFlag: $("#yfFlag").val(),
        isEdit: $("#groupNo").attr("readonly") == 'readonly' ? 1 : 0 //1：修改 0：新增
    });
    $.ajax({
        type: "POST",
        url: '/thmz/saveGroupName',
        contentType: "application/json;charset=UTF-8",
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        data: data,
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $("#editModal").modal("hide");
                clearInput();
                $('#tb_table').bootstrapTable('refresh');
                successMesage(res);
            } else {
                errorMesage(res);
            }
        }
    });
}


/**
 * 清空输入框
 */
function clearInput() {
    $("#groupNo").attr("readonly", false);
    $("#groupNo").val(null);
    $("#groupName").val(null);
    $("#deptCode").val(null);
    $("#mzFlag").val(null);
    $("#yfFlag").val(null);
    $("#deptCode").selectpicker('refresh');
}

/**
 * 重置查询表单
 */
function resetSearch() {
    $("#groupNoSearch").val(null);
    $("#groupNameSearch").val(null);
}


/**
 * 查询药房库列表
 */
function getAllGroupName() {
    $('#tb_table').bootstrapTable("destroy");
    $('#tb_table').bootstrapTable({
        url: '/thmz/listYpZdGroupName',         //请求后台的URL（*）
        method: 'post',                      //请求方式（*）
        toolbar: '#toolbar',                //工具按钮用哪个容器
        striped: true,                      //是否显示行间隔色
        cache: false,                       //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        pagination: true,                   //是否显示分页（*）
        sortable: true,                     //是否启用排序
        sortOrder: "desc",                   //排序方式
        queryParams: queryParams,           //传递参数（*）
        sidePagination: "server",           //分页方式：client客户端分页，server服务端分页（*）
        pageNumber: 1,                       //初始化加载第一页，默认第一页
        pageSize: 10,                       //每页的记录行数（*）
        pageList: [10, 15, 25, 50, 100],        //可供选择的每页的行数（*）
        search: false,                       //是否显示表格搜索，此搜索是客户端搜索，不会进服务端，所以，个人感觉意义不大
        strictSearch: true,
        showColumns: false,                  //是否显示所有的列
        showRefresh: false,                  //是否显示刷新按钮
        minimumCountColumns: 2,             //最少允许的列数
        clickToSelect: true,                //是否启用点击选中行
        uniqueId: "groupNo",                     //每一行的唯一标识，一般为主键列
        showToggle: false,                    //是否显示详细视图和列表视图的切换按钮
        cardView: false,                    //是否显示详细视图
        detailView: false,
        //rowStyle:rowStyle,//通过自定义函数设置行样式
        ajaxOptions: {
            headers: {
                'Accept': 'application/json',
                'Authorization': 'Bearer ' + localStorage.getItem("token")
            }
        },
        columns: [
            {
                title: '操作',
                field: 'op',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    var groupNo = row.groupNo;
                    row = JSON.stringify(row);
                    var str = '<button type="button" class="btn btn-primary  btn-sm" onclick=updateYpZdGroupName(' + row + ')>编辑</button>';
                   /* str += '<button type="button" class="btn btn-warning  btn-sm" onclick=removeByGroupNo(' + groupNo + ')>删除</button>';*/
                    return [str].join('');
            }
            },
            {
                field: 'groupNo',
                title: '药房编码',
                align: "center",
                valign: 'middle'
            }, {
                field: 'groupName',
                title: '药房名称',
                align: "center",
                valign: 'middle'
            }, {
                field: 'deptName',
                title: '部门',
                align: "center",
                valign: 'middle'
            }, {
                field: 'pyCode',
                title: '拼音编码',
                align: "center",
                valign: 'middle'
            }, {
                field: 'wbCode',
                title: '五笔编码',
                align: "center",
                valign: 'middle',
            }, {
                field: 'mzFlag',
                title: '是否门诊',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    return value == 0 ? '否' : '是';
                }
            }, {
                field: 'yfFlag',
                title: '是否药房',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    return value == 0 ? '否' : '是';
                }
            }
        ],
        responseHandler: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            var ress = eval(res);
            if (ress.code == -1) {
                if (ress.message != null && ress.message != '') {
                    new PNotify({
                        title: '错误提示',
                        text: ress.message,
                        type: 'error',
                        hide: true,
                        styling: 'bootstrap3'
                    });
                }
                return {
                    "total": 0,//总页数
                    "rows": {}   //数据
                };
            }
            return {
                "total": ress.total,//总页数
                "rows": ress.data   //数据
            };
        },
    });
}


/**
 * 构建列表查询参数
 * @param params
 * @returns {{mzChargeDetail: {patientId: string | number | string[] | undefined | jQuery, warnDept: string | number | string[] | undefined | jQuery, doctorCode: string | number | string[] | undefined | jQuery, name: string | number | string[] | undefined | jQuery, payMark: number}, beginTime: Date, endTime: Date, pageSize: *, pageIndex: number}}
 */
function queryParams(params) {
    var temp = {   //这里的键的名字和控制器的变量名必须一直，这边改动，控制器也需要改成一样的
        pageSize: params.limit,   //页面大小
        pageIndex: params.offset / params.limit,  //页码
        ypZdGroupName: {
            groupNo: $("#groupNoSearch").val() == "" ? null : $("#groupNoSearch").val(),
            groupName: $("#groupNameSearch").val() == "" ? null : $("#groupNameSearch").val()
        }
    };
    return temp;
}


/**
 * 打开编辑窗口
 * @param row
 */
function updateYpZdGroupName(row) {
    clearInput();
    $("#groupNo").attr("readonly", true);
    $("#classTitle").text("修改");
    $("#groupNo").val(row.groupNo);
    $("#groupName").val(row.groupName);
    $("#mzFlag").val(row.mzFlag);
    $("#yfFlag").val(row.yfFlag);
    $("#deptCode").val(row.deptCode);
    $("#deptCode").selectpicker('refresh');
    $("#editModal").modal();
}

/**
 * 删除药房
 * @param id
 */
function removeByGroupNo(groupNo) {
    if (!confirm("是否要删除当前药房？")) {
        return;
    }
    $.ajax({
        type: "GET",
        url: '/thmz/removeByGroupNo?groupNo=' + groupNo,
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $('#tb_table').bootstrapTable('refresh');
                successMesage(res);
            } else {
                errorMesage(res);
            }
        }
    });
}
